// -------------------------------------------------------------------------
// japan: タブレット用日本地図を使った県名を当てるゲーム
// ver 1.2
// 					created at 2016-02-03 on trisky.com
//
//					履歴
//					v1.0		2016-02-03 公開バージョン1
//					v0.7		2016-01-26 エフェクト追加
//					v0.6		2016-01-25 とりあえずゲームとして動く
//					v0.5.1	2015-08-31 開発再開
//					v0.5		2014-01-10 開発を始めたが途中で中止
// -------------------------------------------------------------------------

/*
 * メイン
 */

window.onload = function(){
	// ゲームオブジェクト生成
	game = new Core(SCREEN_WIDTH, SCREEN_HEIGHT);
	// 画像を読み込み
	game.preload(MAP_ASSETS);
	game.preload(ASSETS);

	// ゲーム開始時の処理
	game.onload = function(){
		// ゲーム状態の設定
		game.mode = START;
		// タイトル画面生成
		scTitle = new Scene();
		scTitle.backgroundColor = BG_TITLE_COLOR;
		// タイトル画像生成
		var title = new Sprite(SCREEN_WIDTH, SCREEN_HEIGHT);
		title.image = game.assets[IMG_TITLE];
		scTitle.addChild(title);
		// タイトル画面に雲くんを3つ生成
		for(var i=0; i<3; i++){
			var kumo = new Kumo(rnd(SCREEN_WIDTH, SCREEN_WIDTH *i), rnd(0, SCREEN_HEIGHT-64), BG_KUMO);
			scTitle.addChild(kumo);
		}
		// ハイスコア表示ラベル
		hiscoreText = new MutableText(SCREEN_WIDTH/2, SCREEN_HEIGHT*2/3, 16*3, "");
		hiscoreText.scaleX = hiscoreText.scaleY = 3.0;
		scTitle.addChild(hiscoreText);
		// タイトル画面でタッチするとゲーム開始
		scTitle.addEventListener("touchstart", function(){
			if(game.mode == START){
				initGame();
				startGame();
			}
		});
		
		// ゲーム画面生成
		scGame = new Scene();
		scGame.backgroundColor = BG_GAME_COLOR;
		// 問題番号表示用ラベル生成
		numberText = new MutableText(12, 30, SCREEN_WIDTH, "");
		numberText.scaleX = numberText.scaleY = 1.0;
		scGame.addChild(numberText);
		// スコア表示用ラベル生成
		scoreText = new MutableText(12, 450, SCREEN_WIDTH, "");
		scoreText.scaleX = scoreText.scaleY = 1.0;
		scGame.addChild(scoreText);
		// 問題表示用スプライト生成
		map = new MapSprite("20nagano.png");
		scGame.addChild(map);
		// 解答ボタン生成（4つ）
		var buttonList = [ [10, 320], [161, 320], [10, 371], [161, 371]];
		for(var i=0; i<buttonList.length; i++){
			var buttonXY = buttonList[i];
			button[i] = new LabelButton(buttonXY[0], buttonXY[1], prefs[19]);
			scGame.addChild(button[i]);
		}

		// ゲーム実行中の全体的な処理
		scGame.addEventListener("enterframe", function(){
			if(game.mode == GAME){
			}
			else if(game.mode == EFFECT){
			}
			else if(game.mode == WAIT){
				if(passedTime > WAIT_TIME){
					scGame.removeChild(endEffect);
					game.mode = START;
					console.log("Mode: " + game.mode);
				}
			}
			else if(game.mode == NEXT){
				if(no == gameEndNo){	// ゲームクリア！
					game.mode = END;
					console.log("Mode: " + game.mode);
					for(var i=0; i<3; i++){	// 派手なエフェクト
						scGame.addChild(new Effect(SCREEN_WIDTH/2-80, SCREEN_HEIGHT/2-100, 160, 60, IMG_GREAT, TYPE_USUAL));
						scGame.addChild(new Effect(rnd(0, SCREEN_WIDTH-358), rnd(0, SCREEN_HEIGHT/4), 358, 180, IMG_FANTASTIC, TYPE_USUAL));
					}
				}
				else{					// 次の問題へ
					game.mode = GAME;
					console.log("Mode: " + game.mode);
					nextQuestion();
				}
			}
			else if(game.mode == END){	// ゲーム終了（ゲームクリア／ゲームオーバー共通）
				game.mode = WAIT;
				console.log("Mode: " + game.mode);
				endEffect = new EndEffect(0, 0, IMG_ENDEFFECT, 0);
				scGame.addChild(endEffect);
			}
			else if(game.mode == START){
				if(game.score > hiscore){	// ハイスコア更新
					hiscore = game.score;
					console.log("ハイスコア更新: " + hiscore);
					hiscoreText.setX("" + hiscore);
					hiscoreText.setText("" + hiscore);
				}
				game.replaceScene(scTitle);
				if(game.score == PREFS){	// 完全制覇エフェクト
					scTitle.addChild(new Effect(SCREEN_WIDTH/2 - 218/2, SCREEN_HEIGHT/2 - 249/2, 218, 249, IMG_CLEAR, TYPE_LAST));
				}
			}
		});
		// 起動時のシーン
		game.pushScene(scTitle);
	};
	game.mode = START;
	console.log("Mode: " + game.mode);
	game.start();
};

/*
 * iPhoneのアドレスバーを消す
 */
 
setTimeout("window.scrollTo(0,1)", 10);
